/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-app-manager-1.0.3-0quantal-20150707-1328/msg/ClientApp.msg
 *
 */


#ifndef APP_MANAGER_MESSAGE_CLIENTAPP_H
#define APP_MANAGER_MESSAGE_CLIENTAPP_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <app_manager/KeyValue.h>
#include <app_manager/KeyValue.h>

namespace app_manager
{
template <class ContainerAllocator>
struct ClientApp_
{
  typedef ClientApp_<ContainerAllocator> Type;

  ClientApp_()
    : client_type()
    , manager_data()
    , app_data()  {
    }
  ClientApp_(const ContainerAllocator& _alloc)
    : client_type(_alloc)
    , manager_data(_alloc)
    , app_data(_alloc)  {
    }



   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _client_type_type;
  _client_type_type client_type;

   typedef std::vector< ::app_manager::KeyValue_<ContainerAllocator> , typename ContainerAllocator::template rebind< ::app_manager::KeyValue_<ContainerAllocator> >::other >  _manager_data_type;
  _manager_data_type manager_data;

   typedef std::vector< ::app_manager::KeyValue_<ContainerAllocator> , typename ContainerAllocator::template rebind< ::app_manager::KeyValue_<ContainerAllocator> >::other >  _app_data_type;
  _app_data_type app_data;




  typedef boost::shared_ptr< ::app_manager::ClientApp_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::app_manager::ClientApp_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct ClientApp_

typedef ::app_manager::ClientApp_<std::allocator<void> > ClientApp;

typedef boost::shared_ptr< ::app_manager::ClientApp > ClientAppPtr;
typedef boost::shared_ptr< ::app_manager::ClientApp const> ClientAppConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::app_manager::ClientApp_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::app_manager::ClientApp_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace app_manager

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'app_manager': ['/tmp/buildd/ros-hydro-app-manager-1.0.3-0quantal-20150707-1328/msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::app_manager::ClientApp_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::app_manager::ClientApp_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::app_manager::ClientApp_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::app_manager::ClientApp_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::app_manager::ClientApp_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::app_manager::ClientApp_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::app_manager::ClientApp_<ContainerAllocator> >
{
  static const char* value()
  {
    return "0a8112672c3fbf73cb62ec78d67e41bb";
  }

  static const char* value(const ::app_manager::ClientApp_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x0a8112672c3fbf73ULL;
  static const uint64_t static_value2 = 0xcb62ec78d67e41bbULL;
};

template<class ContainerAllocator>
struct DataType< ::app_manager::ClientApp_<ContainerAllocator> >
{
  static const char* value()
  {
    return "app_manager/ClientApp";
  }

  static const char* value(const ::app_manager::ClientApp_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::app_manager::ClientApp_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# like \"android\" or \"web\" or \"linux\"\n\
string client_type\n\
\n\
# like \"intent = ros.android.teleop\" and \"accelerometer = true\", used to choose which ClientApp to use\n\
KeyValue[] manager_data\n\
\n\
# parameters which just get passed through to the client app.\n\
KeyValue[] app_data\n\
\n\
================================================================================\n\
MSG: app_manager/KeyValue\n\
string key\n\
string value\n\
";
  }

  static const char* value(const ::app_manager::ClientApp_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::app_manager::ClientApp_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.client_type);
      stream.next(m.manager_data);
      stream.next(m.app_data);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct ClientApp_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::app_manager::ClientApp_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::app_manager::ClientApp_<ContainerAllocator>& v)
  {
    s << indent << "client_type: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.client_type);
    s << indent << "manager_data[]" << std::endl;
    for (size_t i = 0; i < v.manager_data.size(); ++i)
    {
      s << indent << "  manager_data[" << i << "]: ";
      s << std::endl;
      s << indent;
      Printer< ::app_manager::KeyValue_<ContainerAllocator> >::stream(s, indent + "    ", v.manager_data[i]);
    }
    s << indent << "app_data[]" << std::endl;
    for (size_t i = 0; i < v.app_data.size(); ++i)
    {
      s << indent << "  app_data[" << i << "]: ";
      s << std::endl;
      s << indent;
      Printer< ::app_manager::KeyValue_<ContainerAllocator> >::stream(s, indent + "    ", v.app_data[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // APP_MANAGER_MESSAGE_CLIENTAPP_H
