/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-app-manager-1.0.3-0quantal-20150707-1328/srv/ListApps.srv
 *
 */


#ifndef APP_MANAGER_MESSAGE_LISTAPPSRESPONSE_H
#define APP_MANAGER_MESSAGE_LISTAPPSRESPONSE_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <app_manager/App.h>
#include <app_manager/App.h>

namespace app_manager
{
template <class ContainerAllocator>
struct ListAppsResponse_
{
  typedef ListAppsResponse_<ContainerAllocator> Type;

  ListAppsResponse_()
    : running_apps()
    , available_apps()  {
    }
  ListAppsResponse_(const ContainerAllocator& _alloc)
    : running_apps(_alloc)
    , available_apps(_alloc)  {
    }



   typedef std::vector< ::app_manager::App_<ContainerAllocator> , typename ContainerAllocator::template rebind< ::app_manager::App_<ContainerAllocator> >::other >  _running_apps_type;
  _running_apps_type running_apps;

   typedef std::vector< ::app_manager::App_<ContainerAllocator> , typename ContainerAllocator::template rebind< ::app_manager::App_<ContainerAllocator> >::other >  _available_apps_type;
  _available_apps_type available_apps;




  typedef boost::shared_ptr< ::app_manager::ListAppsResponse_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::app_manager::ListAppsResponse_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct ListAppsResponse_

typedef ::app_manager::ListAppsResponse_<std::allocator<void> > ListAppsResponse;

typedef boost::shared_ptr< ::app_manager::ListAppsResponse > ListAppsResponsePtr;
typedef boost::shared_ptr< ::app_manager::ListAppsResponse const> ListAppsResponseConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::app_manager::ListAppsResponse_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::app_manager::ListAppsResponse_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace app_manager

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'app_manager': ['/tmp/buildd/ros-hydro-app-manager-1.0.3-0quantal-20150707-1328/msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::app_manager::ListAppsResponse_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::app_manager::ListAppsResponse_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::app_manager::ListAppsResponse_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::app_manager::ListAppsResponse_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::app_manager::ListAppsResponse_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::app_manager::ListAppsResponse_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::app_manager::ListAppsResponse_<ContainerAllocator> >
{
  static const char* value()
  {
    return "8a71ede6bf51909653c7c551f462cb30";
  }

  static const char* value(const ::app_manager::ListAppsResponse_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x8a71ede6bf519096ULL;
  static const uint64_t static_value2 = 0x53c7c551f462cb30ULL;
};

template<class ContainerAllocator>
struct DataType< ::app_manager::ListAppsResponse_<ContainerAllocator> >
{
  static const char* value()
  {
    return "app_manager/ListAppsResponse";
  }

  static const char* value(const ::app_manager::ListAppsResponse_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::app_manager::ListAppsResponse_<ContainerAllocator> >
{
  static const char* value()
  {
    return "App[] running_apps\n\
App[] available_apps\n\
\n\
================================================================================\n\
MSG: app_manager/App\n\
# app name\n\
string name\n\
# user-friendly display name of application\n\
string display_name\n\
# icon for showing app\n\
Icon icon\n\
# ordered list (by preference) of client applications to interact with this robot app.  \n\
ClientApp[] client_apps\n\
\n\
================================================================================\n\
MSG: app_manager/Icon\n\
# Image data format.  \"jpeg\" or \"png\"\n\
string format\n\
\n\
# Image data.\n\
uint8[] data\n\
\n\
================================================================================\n\
MSG: app_manager/ClientApp\n\
# like \"android\" or \"web\" or \"linux\"\n\
string client_type\n\
\n\
# like \"intent = ros.android.teleop\" and \"accelerometer = true\", used to choose which ClientApp to use\n\
KeyValue[] manager_data\n\
\n\
# parameters which just get passed through to the client app.\n\
KeyValue[] app_data\n\
\n\
================================================================================\n\
MSG: app_manager/KeyValue\n\
string key\n\
string value\n\
";
  }

  static const char* value(const ::app_manager::ListAppsResponse_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::app_manager::ListAppsResponse_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.running_apps);
      stream.next(m.available_apps);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct ListAppsResponse_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::app_manager::ListAppsResponse_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::app_manager::ListAppsResponse_<ContainerAllocator>& v)
  {
    s << indent << "running_apps[]" << std::endl;
    for (size_t i = 0; i < v.running_apps.size(); ++i)
    {
      s << indent << "  running_apps[" << i << "]: ";
      s << std::endl;
      s << indent;
      Printer< ::app_manager::App_<ContainerAllocator> >::stream(s, indent + "    ", v.running_apps[i]);
    }
    s << indent << "available_apps[]" << std::endl;
    for (size_t i = 0; i < v.available_apps.size(); ++i)
    {
      s << indent << "  available_apps[" << i << "]: ";
      s << std::endl;
      s << indent;
      Printer< ::app_manager::App_<ContainerAllocator> >::stream(s, indent + "    ", v.available_apps[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // APP_MANAGER_MESSAGE_LISTAPPSRESPONSE_H
