/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-app-manager-1.0.3-0quantal-20150707-1328/srv/UninstallApp.srv
 *
 */


#ifndef APP_MANAGER_MESSAGE_UNINSTALLAPPRESPONSE_H
#define APP_MANAGER_MESSAGE_UNINSTALLAPPRESPONSE_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace app_manager
{
template <class ContainerAllocator>
struct UninstallAppResponse_
{
  typedef UninstallAppResponse_<ContainerAllocator> Type;

  UninstallAppResponse_()
    : uninstalled(false)
    , message()  {
    }
  UninstallAppResponse_(const ContainerAllocator& _alloc)
    : uninstalled(false)
    , message(_alloc)  {
    }



   typedef uint8_t _uninstalled_type;
  _uninstalled_type uninstalled;

   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _message_type;
  _message_type message;




  typedef boost::shared_ptr< ::app_manager::UninstallAppResponse_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::app_manager::UninstallAppResponse_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct UninstallAppResponse_

typedef ::app_manager::UninstallAppResponse_<std::allocator<void> > UninstallAppResponse;

typedef boost::shared_ptr< ::app_manager::UninstallAppResponse > UninstallAppResponsePtr;
typedef boost::shared_ptr< ::app_manager::UninstallAppResponse const> UninstallAppResponseConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::app_manager::UninstallAppResponse_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::app_manager::UninstallAppResponse_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace app_manager

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'app_manager': ['/tmp/buildd/ros-hydro-app-manager-1.0.3-0quantal-20150707-1328/msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::app_manager::UninstallAppResponse_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::app_manager::UninstallAppResponse_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::app_manager::UninstallAppResponse_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::app_manager::UninstallAppResponse_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::app_manager::UninstallAppResponse_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::app_manager::UninstallAppResponse_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::app_manager::UninstallAppResponse_<ContainerAllocator> >
{
  static const char* value()
  {
    return "335f3f18ef026f9358ef38ecb7785332";
  }

  static const char* value(const ::app_manager::UninstallAppResponse_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x335f3f18ef026f93ULL;
  static const uint64_t static_value2 = 0x58ef38ecb7785332ULL;
};

template<class ContainerAllocator>
struct DataType< ::app_manager::UninstallAppResponse_<ContainerAllocator> >
{
  static const char* value()
  {
    return "app_manager/UninstallAppResponse";
  }

  static const char* value(const ::app_manager::UninstallAppResponse_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::app_manager::UninstallAppResponse_<ContainerAllocator> >
{
  static const char* value()
  {
    return "\n\
bool uninstalled\n\
string message\n\
\n\
";
  }

  static const char* value(const ::app_manager::UninstallAppResponse_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::app_manager::UninstallAppResponse_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.uninstalled);
      stream.next(m.message);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct UninstallAppResponse_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::app_manager::UninstallAppResponse_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::app_manager::UninstallAppResponse_<ContainerAllocator>& v)
  {
    s << indent << "uninstalled: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.uninstalled);
    s << indent << "message: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.message);
  }
};

} // namespace message_operations
} // namespace ros

#endif // APP_MANAGER_MESSAGE_UNINSTALLAPPRESPONSE_H
